summaryrefslogtreecommitdiffstats
path: root/libraries/hyperscan
diff options
context:
space:
mode:
author Ebben Aries2018-10-30 17:39:26 +0100
committer Willy Sudiarto Raharjo2018-11-03 01:46:39 +0100
commite2114fd37616faaf85368fa06bafafb1ec3a9587 (patch)
tree4abb86739cc8db610b9d922eb6b399ecf273c3d9 /libraries/hyperscan
parentf8511a674e600e493ac3e039bf681a871aeb3d18 (diff)
downloadslackbuilds-e2114fd37616faaf85368fa06bafafb1ec3a9587.tar.gz
libraries/hyperscan: Added (regex matching library).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'libraries/hyperscan')
-rw-r--r--libraries/hyperscan/README9
-rw-r--r--libraries/hyperscan/boost_distance.patch20
-rw-r--r--libraries/hyperscan/hyperscan.SlackBuild103
-rw-r--r--libraries/hyperscan/hyperscan.info10
-rw-r--r--libraries/hyperscan/slack-desc19
5 files changed, 161 insertions, 0 deletions
diff --git a/libraries/hyperscan/README b/libraries/hyperscan/README
new file mode 100644
index 0000000000..f3e2895877
--- /dev/null
+++ b/libraries/hyperscan/README
@@ -0,0 +1,9 @@
+hyperscan (A high-performance multiple regex matching library)
+
+Hyperscan is a high-performance multiple regex matching library. It
+follows the regular expression syntax of the commonly-used PCRE library,
+yet functions as a standalone library with its own API written in C.
+
+Hyperscan uses hybrid automata techniques to allow simultaneous matching
+of large numbers (up to tens of thousands) of regular expressions, as
+well as matching of regular expressions across streams of data.
diff --git a/libraries/hyperscan/boost_distance.patch b/libraries/hyperscan/boost_distance.patch
new file mode 100644
index 0000000000..36f13807ea
--- /dev/null
+++ b/libraries/hyperscan/boost_distance.patch
@@ -0,0 +1,20 @@
+--- src/nfa/limex_compile.cpp 2018-10-27 20:19:18.832643025 -0600
++++ src/nfa/limex_compile.cpp 2018-10-27 20:20:03.814690090 -0600
+@@ -980,7 +980,7 @@
+ // see if we've already seen it, otherwise add a new one.
+ auto it = find(squash.begin(), squash.end(), sit->second);
+ if (it != squash.end()) {
+- return verify_u32(distance(squash.begin(), it));
++ return verify_u32(std::distance(squash.begin(), it));
+ }
+ u32 idx = verify_u32(squash.size());
+ squash.push_back(sit->second);
+@@ -1007,7 +1007,7 @@
+ auto it = search(begin(reports), end(reports), begin(my_reports),
+ end(my_reports));
+ if (it != end(reports)) {
+- u32 offset = verify_u32(distance(begin(reports), it));
++ u32 offset = verify_u32(std::distance(begin(reports), it));
+ DEBUG_PRINTF("reusing found report list at %u\n", offset);
+ return offset;
+ }
diff --git a/libraries/hyperscan/hyperscan.SlackBuild b/libraries/hyperscan/hyperscan.SlackBuild
new file mode 100644
index 0000000000..c90bbc8463
--- /dev/null
+++ b/libraries/hyperscan/hyperscan.SlackBuild
@@ -0,0 +1,103 @@
+#!/bin/sh
+
+# Slackware build script for Hyperscan
+
+# Copyright 2018 Ebben Aries <e@dscp.org>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=hyperscan
+VERSION=${VERSION:-5.0.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# https://github.com/intel/hyperscan/issues/104
+patch -p0 --verbose < $CWD/boost_distance.patch
+
+sed -i -e 's/mktemp/mktemp-gnu/' cmake/build_wrapper.sh
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_INSTALL_DOCDIR=/usr/doc/$PRGNAM-$VERSION \
+ -DBUILD_STATIC_AND_SHARED=ON \
+ -DCMAKE_BUILD_TYPE=Release \
+ ..
+ make
+ make install DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a CHANGELOG.md COPYING LICENSE README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/hyperscan/hyperscan.info b/libraries/hyperscan/hyperscan.info
new file mode 100644
index 0000000000..a97d73dd33
--- /dev/null
+++ b/libraries/hyperscan/hyperscan.info
@@ -0,0 +1,10 @@
+PRGNAM="hyperscan"
+VERSION="5.0.0"
+HOMEPAGE="https://www.hyperscan.io"
+DOWNLOAD="https://github.com/intel/hyperscan/archive/v5.0.0/hyperscan-5.0.0.tar.gz"
+MD5SUM="353f889bf6b35712a03f136acd9ea260"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="ragel"
+MAINTAINER="Ebben Aries"
+EMAIL="e@dscp.org"
diff --git a/libraries/hyperscan/slack-desc b/libraries/hyperscan/slack-desc
new file mode 100644
index 0000000000..7f96d4efd6
--- /dev/null
+++ b/libraries/hyperscan/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+hyperscan: hyperscan (regex matching library)
+hyperscan:
+hyperscan: Hyperscan is a high-performance multiple regex matching library. It
+hyperscan: follows the regular expression syntax of the commonly-used PCRE
+hyperscan: library, yet functions as a standalone library with its own API
+hyperscan: written in C.
+hyperscan:
+hyperscan:
+hyperscan:
+hyperscan:
+hyperscan: